# HG changeset patch
# Node ID e5a50132dbb0
# Parent  862153de4f30
diff --git a/doc/reference/libpurple/libpurple.toml.in b/doc/reference/libpurple/libpurple.toml.in
new file mode 100644
--- /dev/null
+++ b/doc/reference/libpurple/libpurple.toml.in
@@ -0,0 +1,60 @@
+[library]
+version = "@PURPLE_VERSION@"
+browse_url = "https://keep.imfreedom.org/pidgin/pidgin/"
+repository_url = "https://keep.imfreedom.org/pidgin/pidgin/"
+website_url = "https://keep.imfreedom.org/pidgin/pidgin/"
+authors = "Pidgin Developers"
+logo_url = ""
+license = "GPL-2.0-or-later"
+description = "Purple Universal Chat Library"
+dependencies = [ "GLib-2.0", "GObject-2.0", "GPlugin-1.0" ]
+devhelp = true
+search_index = true
+
+  [dependencies."GLib-2.0"]
+  name = "GLib"
+  description = "General-purpose, portable utility library."
+  docs_url = "https://docs.gtk.org/glib/"
+
+  [dependencies."GObject-2.0"]
+  name = "GObject"
+  description = "The base type system library"
+  docs_url = "https://docs.gtk.org/gobject/"
+
+  [dependencies."GPlugin-1.0"]
+  name = "GPlugin"
+  description = "GPlugin Plugin Library"
+  docs_urls = "https://docs.imfreedom.org/gplugin/"
+
+[theme]
+name = "basic"
+show_index_summary = true
+show_class_hierarchy = true
+
+[source-location]
+base_url = "https://keep.imfreedom.org/pidgin/pidgin/file/default/"
+
+[extra]
+# The same order will be used when generating the index
+content_files = [
+	"code_contributions.md",
+	"mercurial.md",
+	"plugin_i18n.md",
+	"plugin_ids.md",
+	"signals_account.md",
+	"signals_blist.md",
+	"signals_cmd.md",
+	"signals_connection.md",
+	"signals_conversation.md",
+	"signals_core.md",
+	"signals_imgstore.md",
+	"signals_jabber.md",
+	"signals_notify.md",
+	"signals_plugin.md",
+	"signals_savedstatus.md",
+	"signals_xfer.md",
+	"tut_c_plugins.md",
+]
+content_images = [
+]
+urlmap_file = "urlmap.js"
diff --git a/doc/reference/libpurple/meson.build b/doc/reference/libpurple/meson.build
--- a/doc/reference/libpurple/meson.build
+++ b/doc/reference/libpurple/meson.build
@@ -1,71 +1,51 @@
-DOC_MODULE = 'libpurple'
-
-# Header files or dirs to ignore when scanning. Use base file/dir names
-ignore_hfiles = [
-    'example',
-    'plugins',
-    'protocols',
-    'tests',
-    'tests.h',
-    'win32',
-    'backend-fs2.h',
-    'glibcompat.h',
-    'internal.h',
-    'purple.h',
-    'purpleenums.h',
-    'purpleprivate.h',
-]
-
-# Extra options to supply to gtkdoc-scan.
-scan_args = [
-    '--deprecated-guards=PURPLE_DISABLE_DEPRECATED',
-    '--rebuild-types',
-    '--rebuild-sections',
-    '--ignore-headers=' + ' '.join(ignore_hfiles),
-]
-
-# Extra options to supply to gtkdoc-mkdb.
-mkdb_args = [
-    '--ignore-files=' + ' '.join(ignore_hfiles),
-]
-
-# Extra options to supply to gtkdoc-fixxref
-fixxref_args = [
+libpurple_doc_content_files = [
+	'code_contributions.md',
+	'mercurial.md',
+	'plugin_i18n.md',
+	'plugin_ids.md',
+	'signals_account.md',
+	'signals_blist.md',
+	'signals_cmd.md',
+	'signals_connection.md',
+	'signals_conversation.md',
+	'signals_core.md',
+	'signals_imgstore.md',
+	'signals_jabber.md',
+	'signals_notify.md',
+	'signals_plugin.md',
+	'signals_savedstatus.md',
+	'signals_xfer.md',
+	'tut_c_plugins.md',
 ]
 
-libpurple_version_xml = configure_file(
-    input : 'version.xml.in',
-    output : 'version.xml',
-    configuration : version_conf)
+if get_option('doc')
+	libpurple_toml = configure_file(
+		input : 'libpurple.toml.in',
+		output : 'libpurple.toml',
+		configuration : version_conf,
+		install : true,
+		install_dir : docs_dir / 'libpurple',
+	)
 
-content_files = [
-    'plugin_i18n.xml',
-    'plugin_ids.xml',
-    'signals_account.xml',
-    'signals_blist.xml',
-    'signals_certificate.xml',
-    'signals_cmd.xml',
-    'signals_connection.xml',
-    'signals_conversation.xml',
-    'signals_core.xml',
-    'signals_jabber.xml',
-    'signals_log.xml',
-    'signals_notify.xml',
-    'signals_plugin.xml',
-    'signals_savedstatus.xml',
-    'signals_xfer.xml',
-    'tut_c_plugins.xml',
-    'tut_signals.xml',
-    'ui_ops.xml',
-]
+	libpurple_doc = custom_target('libpurple-doc',
+		input : [ libpurple_toml, libpurple_gir[0] ],
+		output : 'libpurple',
+		command : [
+			gidocgen,
+			'generate',
+			'--quiet',
+			'--fatal-warnings',
+			'--config=@INPUT0@',
+			'--output-dir=@OUTPUT@',
+			'--no-namespace-dir',
+			'--content-dir=@0@'.format(meson.current_source_dir()),
+			'--add-include-path=@0@'.format(meson.global_build_root() / 'subprojects/gplugin/gplugin'),
+			'@INPUT1@'
+		],
+		depend_files : [ libpurple_doc_content_files ],
+		build_by_default : true,
+		install : true,
+		install_dir : docs_dir,
+	)
+endif
 
-libpurple_doc = gnome.gtkdoc(DOC_MODULE,
-    main_xml : DOC_MODULE + '-docs.xml',
-    src_dir : libpurple_inc,
-    dependencies : libpurple_dep,
-    install : true,
-    scan_args : scan_args,
-    mkdb_args : mkdb_args,
-    fixxref_args: fixxref_args,
-    gobject_typesfile : DOC_MODULE + '.types',
-    content_files : content_files)
diff --git a/doc/reference/libpurple/urlmap.js b/doc/reference/libpurple/urlmap.js
new file mode 100644
--- /dev/null
+++ b/doc/reference/libpurple/urlmap.js
@@ -0,0 +1,9 @@
+// SPDX-FileCopyrightText: 2021 GNOME Foundation
+// SPDX-License-Identifier: LGPL-2.1-or-later
+
+// A map between namespaces and base URLs for their online documentation
+baseURLs = [
+    [ 'GLib', 'https://docs.gtk.org/glib/' ],
+    [ 'GObject', 'https://docs.gtk.org/gobject/' ],
+    [ 'GPlugin', 'https://docs.imfreedom.org/gplugin/' ],
+]
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -328,6 +328,7 @@
 	libpurple_gir = gnome.generate_gir(libpurple,
 	    sources : introspection_sources,
 	    includes : ['GLib-2.0', 'Gio-2.0', 'GObject-2.0', 'Gst-1.0', 'GPlugin-1.0'],
+	    header : 'purple.h',
 	    namespace : 'Purple',
 	    symbol_prefix : 'purple',
 	    identifier_prefix : 'Purple',
